@echo off

:Menu
cls
echo                    ##################################################
echo                    #                                                #
echo                    #             RomHacking Tutorial                #
echo                    #             Batch v3.5 by Asia81               #
echo                    #              Updated 08/06/2015                #
echo                    #                                                #
echo                    ##################################################
echo.
echo - Enter D for extract a decrypted rom
echo - Enter SDK6 for extract a SDK6 (or lower) game
echo - Enter SDK7 for extract a SDK7 (or higher) game
echo - Enter fs for extract a ExeFS or RomFS
echo - Enter pad for use Padxorer
echo - Enter SD for use SDinfo_gen.py
echo - Enter fat16 to extract / inject a FAT16 partition from a NAND file
echo - Enter exit for... exit :)
echo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
echo.
set /p Menu=Your choice: 
if /i %Menu%==D GOTO Decrypted
if /i %Menu%==SDK6 GOTO SDK6
if /i %Menu%==SDK7 GOTO SDK7
if /i %Menu%==fs GOTO ExtractPartitionData
if /i %Menu%==romfs GOTO ExtractRomFS
if /i %Menu%==exefs GOTO ExtractExeFS
if /i %Menu%==pad GOTO Padxorer
if /i %Menu%==sd GOTO SD
if /i %Menu%==fat16 GOTO FAT16
if /i %Menu%==exit goto:eof

:Decrypted
cls
echo.
set /p Name=Enter the name of your 3DS Rom (Without .3ds): 
echo.
ctrtool -p --exheader=DecryptedExHeader.bin %Name%.3ds
ctrtool -p --exefs=DecryptedExeFS.bin %Name%.3ds
ctrtool -p --romfs=DecryptedRomFS.bin %Name%.3ds
echo.
ctrtool.exe -t romfs --romfsdir=./romfs DecryptedRomFS.bin
goto:ExtractExeFS

:SDK6
cls
echo.
set /p Nom=The name of the Decrypted App or 3DS file (With Extension): 
echo.
set /p TitleID=Enter the TitleID of your game: 
echo.
ctrtool -p --exheader=EncryptedExHeader.bin %Nom%
ctrtool -p --exefs=EncryptedExeFS.bin %Nom%
ctrtool -p --romfs=EncryptedRomFS.bin %Nom%
echo.
padxorer.exe EncryptedExHeader.bin %TitleID%.Main.exheader.xorpad
padxorer.exe EncryptedExeFS.bin %TitleID%.Main.exefs_norm.xorpad
padxorer.exe EncryptedRomFS.bin %TitleID%.Main.romfs.xorpad
echo.
del EncryptedExHeader.bin
del EncryptedExeFS.bin
del EncryptedRomFS.bin
echo.
Ren "EncryptedExHeader.bin.out" "DecryptedExHeader.bin"
Ren "EncryptedExeFS.bin.out" "DecryptedExeFS.bin"
Ren "EncryptedRomFS.bin.out" "DecryptedRomFS.bin"
echo.
ctrtool.exe -t romfs --romfsdir=./romfs DecryptedRomFS.bin
goto:ExtractExeFS

:SDK7
cls
echo.
set /p Name=The name of the Decrypted App or 3DS file (With Extension): 
echo.
set /p TitleID=Enter the TitleID of your game: 
echo.
ctrtool -p --exheader=EncryptedExHeader.bin %Name%
ctrtool -p --exefs=EncryptedExeFS.bin %Name%
ctrtool -p --romfs=EncryptedRomFS.bin %Name%
echo.
padxorer.exe EncryptedExHeader.bin %TitleID%.Main.exheader.xorpad
MEX.py EncryptedExeFS.bin %TitleID%.Main.exefs_norm.xorpad %TitleID%.Main.exefs_7x.xorpad EditedExeFS.xorpad
padxorer.exe EncryptedExeFS.bin EditedExeFS.xorpad
padxorer.exe EncryptedRomFS.bin %TitleID%.Main.romfs.xorpad
echo.
del EncryptedExHeader.bin
del EncryptedExeFS.bin
del EncryptedRomFS.bin
echo.
Ren "EncryptedExHeader.bin.out" "DecryptedExHeader.bin"
Ren "EncryptedExeFS.bin.out" "DecryptedExeFS.bin"
Ren "EncryptedRomFS.bin.out" "DecryptedRomFS.bin"
echo.
ctrtool.exe -t romfs --romfsdir=./romfs DecryptedRomFS.bin
goto:ExtractExeFS

:ExtractPartitionData
cls
echo.
echo               Please name your files like this:
echo           DecryptedExeFS.bin or DecryptedRomFS.bin
echo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
echo.
set /p Partition=Enter the partition name to be extracted (exefs/romfs): 
if /i %Partition%==exefs GOTO ExtractExeFS
if /i %Partition%==romfs GOTO ExtractRomFS

:ExtractRomFS
cls
echo.
ctrtool.exe -t romfs --romfsdir=./romfs DecryptedRomFS.bin
echo.
pause
goto:Menu

:ExtractExeFS
cls
echo.
set /p DecompressCode=Decompress the code.bin file (no/yes) ?: 
if %DecompressCode%==no GOTO ExeFS1
if %DecompressCode%==yes GOTO ExeFS2

:ExeFS1
cls
echo.
ctrtool.exe -t exefs --exefsdir=./exe DecryptedExeFS.bin
echo.
goto:Menu

:ExeFS2
cls
echo.
ctrtool.exe -t exefs --exefsdir=./exe DecryptedExeFS.bin --decompresscode
ren exe\code.bin .code.bin
echo.
goto:Menu

:Padxorer
cls
echo.
set /p File=Enter the file name (Without Extension): 
echo.
set /p Extension=Now, enter the extension: 
echo.
set /p Xorpad=Enter the name of the Xorpad (Without .xorpad): 
echo.
Padxorer.exe %File%.%Extension% %Xorpad%.xorpad
echo.
pause
goto:Menu

:SD
cls
echo.
set /p SD=Use the normal version or decrypt9 version (n/d9)?: 
if /i %SD%==n GOTO SD-Normal
if /i %SD%==d9 GOTO SD-Decrypt9

:SD-Normal
cls
echo.
echo You must install the CIA to decrypt on your SysNand.
echo Or on an EmuNand linked with the SysNand.
echo.
echo Target the folder of your SysNand, it looks like: F:\Nintendo 3DS\"ID1"\"ID2"\
echo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
echo.
set /p Path=Now enter this path: 
echo.
SD_Info_Normal.py "%Path%"
echo.
pause
goto:Menu

:SD-Decrypt9
cls
echo.
echo You must install the CIA to decrypt on your SysNand.
echo Or on an EmuNand linked with the SysNand.
echo.
echo Target the folder of your SysNand, it looks like: F:\Nintendo 3DS\"ID1"\"ID2"\
echo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
echo.
set /p Path=Now enter this path: 
echo.
SD_Info_Decrypt9.py "%Path%"
echo.
pause
goto:Menu

:FAT16
cls
echo.
echo Enter 1 for Dump a FAT16 partition from a Nand file
echo Enter 2 for Inject a FAT16 partition into a Nand file
echo.
echo Enter 3 for use Padxorer on your Nand.bin file
echo Enter 4 for use Padxorer on your EmuNand.bin file
echo.
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
echo.
set /p Menu=Now enter your choice: 
if /i %Menu%==1 GOTO Part1
if /i %Menu%==2 GOTO Part2
if /i %Menu%==3 GOTO Part3
if /i %Menu%==4 GOTO Part4

:Part1
cls
echo.
echo Be sure to also have the nand.fat16.xorpad file in that same folder
echo.
set /p Model=Dump from an Old3DS Nand or a New3DS Nand (o/n)?: 
if /i %Model%==o GOTO DumpFAT16Old3DS
if /i %Model%==n GOTO DumpFAT16New3DS

:DumpFAT16Old3DS
cls
echo.
set /p O_SysEmu=Dump from a SysNand (Nand.bin) or an EmuNand (EmuNand.bin) (s/e)?: 
if /i %O_SysEmu%==s GOTO DumpOldSysFAT16
if /i %O_SysEmu%==e GOTO DumpOldEmuFAT16

:DumpOldSysFAT16
cls
echo.
3DSFAT16Tool -d -o Nand.bin Nand.Fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:DumpOldEmuFAT16
cls
echo.
3DSFAT16Tool -d -o EmuNand.bin EmuNand.Fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:DumpFAT16New3DS
cls
echo.
set /p N_SysEmu=Dump from a SysNand (Nand.bin) or EmuNand (EmuNand.bin) (s/e)?: 
if /i %N_SysEmu%==s GOTO DumpNewSysFAT16
if /i %N_SysEmu%==e GOTO DumpNewEmuFAT16

:DumpNewSysFAT16
cls
echo.
3DSFAT16Tool -d -n Nand.bin Nand.Fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:DumpNewEmuFAT16
cls
echo.
3DSFAT16Tool -d -n EmuNand.bin EmuNand.Fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:Part2
cls
echo.
echo Be sure to also have the nand.fat16.xorpad file in that same folder
echo.
set /p Model=Injec the FAT16 partition into an Old3DS Nand or New3DS Nand (o/n)?: 
if /i %Model%==o GOTO InjectFAT16Old3DS
if /i %Model%==n GOTO InjectFAT16New3DS

:InjectFAT16Old3DS
cls
echo.
set /p O_SysEmu=Inject into a SysNand (Nand.bin) or EmuNand (EmuNand.bin) (s/e)?: 
if /i %O_SysEmu%==s GOTO InjectOldSysFAT16
if /i %O_SysEmu%==e GOTO InjectOldEmuFAT16

:InjectOldSysFAT16
cls
echo.
3DSFAT16Tool.exe -i -o Nand.bin Nand.fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:InjectOldEmuFAT16
cls
echo.
3DSFAT16Tool.exe -i -o EmuNand.bin EmuNand.fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:InjectFAT16New3DS
cls
echo.
set /p N_SysEmu=Inject into a SysNand (Nand.bin) or EmuNand (EmuNand.bin) (s/e)?: 
if /i %N_SysEmu%==s GOTO InjectNewSysFAT16
if /i %N_SysEmu%==e GOTO InjectNewEmuFAT16

:InjectNewSysFAT16
cls
echo.
3DSFAT16Tool.exe -i -n Nand.bin Nand.fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:InjectNewEmuFAT16
cls
echo.
3DSFAT16Tool.exe -i -n EmuNand.bin EmuNand.fat16.bin NAND.fat16.xorpad
echo.
goto:menu

:Part3
cls
echo.
Padxorer Nand.bin nand.fat16.xorpad
echo.
pause
goto:menu

:Part4
cls
echo.
Padxorer EmuNand.bin nand.fat16.xorpad
echo.
pause
goto:menu